Bug 1410223 - Slow scrolling/lag when updating terminal
Summary: Slow scrolling/lag when updating terminal
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: xorg-x11-drv-intel
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Adam Jackson
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-04 19:53 UTC by Ralf Ertzinger
Modified: 2017-12-12 10:15 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-12 10:15:31 UTC
Type: Bug


Attachments (Terms of Use)
.Xresources file (962 bytes, text/plain)
2017-01-04 19:53 UTC, Ralf Ertzinger
no flags Details
oprofile output (230.00 KB, application/x-tar)
2017-01-07 17:22 UTC, Ralf Ertzinger
no flags Details
oprofile system wide output (157.96 KB, application/x-gzip)
2017-01-11 19:31 UTC, Ralf Ertzinger
no flags Details
debuginfo packages (2.39 KB, text/plain)
2017-01-11 19:32 UTC, Ralf Ertzinger
no flags Details
opreport output (408.23 KB, text/plain)
2017-01-11 19:32 UTC, Ralf Ertzinger
no flags Details
Xorg log file (21.00 KB, text/plain)
2017-01-11 19:38 UTC, Ralf Ertzinger
no flags Details

Description Ralf Ertzinger 2017-01-04 19:53:14 UTC
Created attachment 1237311 [details]
.Xresources file

Description of problem:
Since the update to F25 output lag in xterm has become much more noticeable.
There is sometime significant delay in updating the screen (for example pressing enter on a full screen shows the last line duplicated before the lowest line is cleared)

Showing fast scrolling content also is significantly slow, and often only shows content in the upper half of the window, while the lower half stays in background color.

Version-Release number of selected component (if applicable):
xterm-327-2.fc25.x86_64


How reproducible:

Show the first 20000 lines from /usr/share/dict/words and time the output using
time head -n 20000 /usr/share/dict/words

xterm with the configuration as attached:
real    0m6.951s
user    0m0.000s
sys     0m0.020s


xterm started as "xterm -fa 'Inconsolata Medium 10'":
real    0m1.475s
user    0m0.001s
sys     0m0.016s

(also the scrolling feels a lot smoother, and less blank space is seen at the bottom of the screen)


gnome-terminal using 'Inconsolata Medium 10' as the font:
real	0m0.061s
user	0m0.000s
sys	0m0.021s

(no noticeable delay)


Desktop environment is Cinnamon.

Comment 1 Ralf Ertzinger 2017-01-04 19:56:18 UTC
urxvt started as "urxvt -fn 'xft:Fixed:pixelsize=14:weight=80'":
real	0m0.041s
user	0m0.002s
sys	0m0.017s

(this looks, to my eyes, exactly as xterm in the default configuration in terms of font rendering)

Comment 2 Miroslav Lichvar 2017-01-06 09:39:47 UTC
It would be interesting to see a perf (or oprofile) report. I suspect it might be a problem in the X driver or the font rendering.

Comment 3 Ralf Ertzinger 2017-01-07 17:21:53 UTC
I've attached the output directory created by a run of

operf xterm -e 'bash -c "head -n 20000 /usr/share/dict/words"'

Comment 4 Ralf Ertzinger 2017-01-07 17:22:48 UTC
Created attachment 1238252 [details]
oprofile output

Comment 5 Miroslav Lichvar 2017-01-09 10:43:56 UTC
Thanks for the data. I don't see anything suspicious there. I'd still suspect something with X or the X driver. Can you try downgrading xterm to the fc24 package and see if it changes anything?

If you are ok with "missing" some data when scrolling, you can enable the fastScroll X resource for xterm. That should give similar performance as the other terminals.

Comment 6 Ralf Ertzinger 2017-01-11 19:31:14 UTC
There seems to be something to this. Taking a system wide profile during the event shows a lot of time being spent in the intel xorg driver (and a lot of CPU time in WAIT).

I still have the raw oprofile data for this, but as far as I can see to make sense of it this requires debuginfo for the exact binaries.

I've attached the new oprofile data dump, the list of installed debuginfo packages and the output I get from opreport.

Comment 7 Ralf Ertzinger 2017-01-11 19:31:50 UTC
Created attachment 1239590 [details]
oprofile system wide output

Comment 8 Ralf Ertzinger 2017-01-11 19:32:18 UTC
Created attachment 1239591 [details]
debuginfo packages

Comment 9 Ralf Ertzinger 2017-01-11 19:32:46 UTC
Created attachment 1239592 [details]
opreport output

Comment 10 Ralf Ertzinger 2017-01-11 19:38:59 UTC
Created attachment 1239597 [details]
Xorg log file

Comment 11 Miroslav Lichvar 2017-01-12 09:16:07 UTC
Ok, let's see if the maintainers of the X driver have any ideas.

Comment 12 Fedora End Of Life 2017-11-16 18:51:38 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 13 Fedora End Of Life 2017-12-12 10:15:31 UTC
Fedora 25 changed to end-of-life (EOL) status on 2017-12-12. Fedora 25 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.